﻿using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Activation;
using na2010v1.Web.Model;

namespace na2010v1.Web.Services
{
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Required)]
    public class Northwind : INorthwind
    {
        public ProductDTODataPage GetProductsForPaging(int pageSize, int startIndex, int resultTotalCount)
        {
            IList<ProductDTO> list = null;

            using (NorthwindDataContext db = new NorthwindDataContext())
            {
                var products = (from p in db.Products
                                select new ProductDTO() 
                                { 
                                    ProductID = p.ProductID,
                                    ProductName = p.ProductName,
                                    UnitPrice = p.UnitPrice
                                }).Skip(startIndex).Take(pageSize);

                if (resultTotalCount == 0)
                {
                    resultTotalCount = (from p in db.Products select p).Count();
                }

                list = products.ToList<ProductDTO>();
            }
            ProductDTODataPage page = new ProductDTODataPage(startIndex, list, resultTotalCount);
            return page;
        }
    }
}
