﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows.Data;
using System.Globalization;
using na2010v1.Model;

namespace na2010v1.Views.xamWebGrid.UnboundColumns
{
    public class UnboundColumnsViewModel : ViewModelBase
    {
        private ObservableCollection<InventoryItem> _items = 
            new ObservableCollection<InventoryItem>();
        
        public ObservableCollection<InventoryItem> Items
        {
            get 
            {
                if (this._items.Count == 0)
                {
                    this._items.Add(new InventoryItem()
                    {
                        Id = 1,
                        Title = "Prarie Dog Pancakes",
                        UnitPrice = 1.75M,
                        UnitsInStock = 10,
                        UnitsOnOrder = 4
                    });

                    this._items.Add(new InventoryItem()
                    {
                        Id = 2,
                        Title = "Gopher Green Wraps",
                        UnitPrice = 1.10M,
                        UnitsInStock = 51,
                        UnitsOnOrder = 29
                    });

                    this._items.Add(new InventoryItem()
                    {
                        Id = 3,
                        Title = "Platypus Popsicles",
                        UnitPrice = 0.75M,
                        UnitsInStock = 12,
                        UnitsOnOrder = 4
                    });

                    this._items.Add(new InventoryItem()
                    {
                        Id = 4,
                        Title = "Porcupine Popcorn Balls",
                        UnitPrice = 2.23M,
                        UnitsInStock = 39,
                        UnitsOnOrder = 0
                    });
                    this.RaisePropertyChangedEvent("Items");
                }
                return this._items;
            }
        }
    }









    public class UnitsConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            InventoryItem item = (InventoryItem)value;
            return item.UnitsInStock + item.UnitsOnOrder;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }











    public class UnitsSorter : IComparer<InventoryItem>
    {
        public int Compare(InventoryItem x, InventoryItem y)
        {
            int x1 = x.UnitsInStock + x.UnitsOnOrder;
            int y1 = y.UnitsInStock + y.UnitsOnOrder;

            return x1.CompareTo(y1);
        }
    }
}
