﻿using System;
using Infragistics.Silverlight;
using na2010v1.NorthwindService;

namespace na2010v1.Views.xamWebGrid.VirtualCollections
{
    public class VcViewModel
    {
        private NorthwindClient _client = null;
        private int _totalCount = 0;

        private VirtualCollection<ProductDTO> _products = null;

        public VirtualCollection<ProductDTO> Products
        {
            get { return this._products; }
        }

        public VcViewModel(int pageSize)
        {
            this.Initialize(pageSize);
        }

        public void Initialize(int pageSize)
        {
            this._products = new VirtualCollection<ProductDTO>(100, pageSize);
            this._products.PageSize = pageSize;
            this._products.ItemDataRequested += new EventHandler<ItemDataRequestedEventArgs>(_products_ItemDataRequested);

            this._client = new NorthwindClient();
            this._client.GetProductsForPagingCompleted += new EventHandler<GetProductsForPagingCompletedEventArgs>(_client_GetProductsForPagingCompleted);
        }

        void _products_ItemDataRequested(object sender, ItemDataRequestedEventArgs e)
        {
            this._client.GetProductsForPagingAsync(this._products.PageSize, e.StartIndex, this._totalCount);
        }

        public void FetchNextPage()
        {
            this._products.MoveToNextPage();
        }

        private void _client_GetProductsForPagingCompleted(object sender, GetProductsForPagingCompletedEventArgs e)
        {
            this._totalCount = e.Result.TotalItemsCount;
            this._products.LoadItems(e.Result.StartIndex, e.Result.DataItems);
        }
    }
}
